/*
Copyright (C) 2008  Damien Thebault

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

struct Asyncns;

#ifndef PY_ASYNCNS_H
#define PY_ASYNCNS_H

#include <Python.h>
#include <asyncns.h>
#include "query.h"

#define PyObject_MyNew(type) type.tp_new(&type, NULL, NULL)

typedef struct Asyncns
{
	PyObject_HEAD
	asyncns_t *asyncns;
	struct Query **queries;
	int nqueries;
} Asyncns;

extern PyTypeObject Asyncns_type;

extern void initAsyncns(PyObject *libasyncns_module);

extern int asyncns_add_query(struct Asyncns *asyncns, struct Query *query);
extern int asyncns_del_query(struct Asyncns *asyncns, struct Query *query);

#endif /* PY_ASYNCNS_H */
