/*
Copyright (C) 2008  Damien Thebault

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2.1 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
*/

struct Query;
struct SubQuery;

#ifndef PY_QUERY_H
#define PY_QUERY_H

#include <Python.h>
#include <asyncns.h>
#include "asyncns.h"

typedef struct Query
{
	PyObject_HEAD
	struct Asyncns *asyncns;
	asyncns_query_t *asyncns_query;
	PyObject *userdata;
	PyObject *result;
} Query;

extern PyTypeObject Query_type;
extern void initQuery(PyObject *libasyncns_module);

extern void Query_store_asyncns(struct Query *self, struct Asyncns *asyncns,
                                asyncns_query_t *asyncns_query);
extern void Query_store_result(struct Query *self, PyObject *result);

extern PyObject *Query_is_done(struct Query *self);
extern PyObject *Query_cancel(struct Query *self);

#endif
